#include <stdlib.h>
#include <stdio.h>
void MvdPackMcmSerial2( int hmbit[16], int tgvbit[8][190], int amubit[8][33], 
                       int SerialBitsOut[1800] )
{
   /* take the serial string bits organized in data for individual   */
   /* chips and put it into SerialBitsOut, which is organized        */
   /* in the order the bits should be sent to the MCM.               */
   /* This version uses the intermediate array datbit2, which        */
   /* is "backwards" compared to SerialBitsOut. This is done to make */
   /* the code more similar to the chaintest program -- which uses   */
   /* the databit2 array.                                            */

   /* input hmbit, tgvbit, amubit                                    */
   /* output SerialBitsOut                                           */

   /* Author = JPSullivan 22-May-2000 (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* Modifications: JPS 4-Aug-2000: had to switch order of bits in  */
   /*                amubit and tgvbit arrays                        */

   /* **********************************************************     */

    int i,j,bcnt,val1,val2;
    int iind;
    int datbit2[1800];

   /* ********************************************************** */

    for (i = 0; i < 16; i++) {
/* remove 10 May 01        datbit2[i] = hmbit[i];  */
        datbit2[i] = hmbit[15-i];                /* heap manager */
    }
    iind = 16;
    
    for (j = 0; j < 8; j++) {
        for (i = 0; i <190; i++) {
            datbit2[iind+i] = tgvbit[j][189-i];  /* TGVs */
        }
        iind += 190;
    }

    for (j = 0; j < 8; j++) {
        for (i = 0; i < 33; i++) {
            datbit2[iind+i] = amubit[j][32-i];  /* AMUs */
        }
        iind += 33;
    }
        
/* take datbit2,  reverse it and put the results into SerialBitsOut */

   for (bcnt = 0; bcnt < 1800; bcnt++) {
      val1 = 1799 - bcnt;	/* bit number */
      val2 = datbit2[val1];  	/* bit value  */
      SerialBitsOut[bcnt] = val2;
        
   }

   return;
}
