#include <stdlib.h>
#include <stdio.h>
void MvdRawMode( char cline[80], int hmbit[16], int amubit[8][33] )
{
   /* Set Raw mode bit on/off                                        */
   /* raw_mode=0 means our normal running condition -- a.k.a.        */
   /*            correlator on -- one packet per level-1 per MCM     */
   /* raw_mode=1 means "raw mode" -- 2 packets per level-1 per MCM   */
   /* even though this command is a "heap manager" command, it also  */
   /* changes the corresponding amu serial string bits. This is done */
   /* because those bits (corr_sel bit in the amu serial string) must*/
   /* have the opposite value compared to this raw_mode bit.         */

   /* input cline, hmbit                                             */

   /*                                                                */
   /* Author = JPSullivan 1 and 2-Aug-2000  (based on labwindows code*/
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   int i;
   char arg1[80];
   char arg2[80];
   int raw_mode; 

   /* ********************************************************** */

   sscanf ( cline, "%s%s%d", arg1, arg2, &raw_mode );
   if ( raw_mode > 1 ) raw_mode = 1;
   if ( raw_mode < 0 ) raw_mode = 0;

   hmbit[12] = raw_mode;
   for ( i=0; i<8; i++ ) 
   {
     amubit[i][6] = 1-raw_mode;
   }

   return;
}
