#include <stdlib.h>
#include <stdio.h>
void MvdReadMcmSerial2( FILE *fpin, int SerialBitsIn[1800] )
{
   /* Read Serial string data from input file */

   /* input = fpin = pointer in (already open) input file */
   /* output= SerialBitsIn */

   /* Author = JPSullivan 23-May-2000 (based on labwindows code */
   /*          originally written by BSchlei and SSRyu) */

   /* ********************************************************** */

    int bitvals[8] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
    int nextbitout;
    int McmSerialCommand;
    int NBytesLower;
    int NBytesUpper;
    int NBytesIn;
    int NBytesExpected;
    int idum1,idum2,idum3;
    int idum4,idum5;
    int inputbyte;
    int i;

   /* ********************************************************** */
    NBytesIn = 0;

    /* read the header */

    fscanf ( fpin, "%3x%3x%3x%3x\n",&idum1, &McmSerialCommand, &idum2, &idum3 );
    fscanf ( fpin, "%3x%3x%3x%3x\n",&idum4, &idum5,&NBytesUpper,&NBytesLower);

    NBytesExpected = ( NBytesUpper << 8 ) | NBytesLower;

    /* fprintf ( stdout, "MvdReadMcmSerial2: NBytesExpected = %d\n", NBytesExpected ); */
    
    /* now read the serial data from the file */

    while ( fscanf ( fpin, "%x", &inputbyte ) != EOF )
    {
        NBytesIn++;
        for ( i=0; i<8; i++)
        {
           nextbitout = ((NBytesIn-1)*8) + i;
           if ( (inputbyte & bitvals[i]) != 0 ) 
              SerialBitsIn[nextbitout]=1;
           else
              SerialBitsIn[nextbitout]=0;

        }
    }

    fclose(fpin);                         /* close input file */
    
    return;

}
