#include <stdlib.h>
#include <stdio.h>
void MvdSetAmuIref( char cline[80], int amuchan, int amubit[8][33] )
{
   /* Set Vcorr DAC value for one AMU/ADC chip                       */

   /* input cline   = the whole command line                         */
   /*       amuchan = the AMU channel this command applies to.       */
   /*                 numbering is 1-8 (not 0-7) because 0 ususally  */
   /*                 means set this bit for all channels.           */
   /*       amubit  = The array of AMU serial string bits (an integer*/
   /*                 array containing 1's and 0's). First index is  */
   /*                 chip number, 2nd is the serial bit number.     */

   /* Author = JPSullivan 3-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int i;
   int amuchan2;
   int bitvals[6] = {0x1, 0x2, 0x4, 0x8, 0x10, 0x20};
   float AMUIREFmin = 2.00;
   float AMUIREFmax = 70.0;
   float volt;
   int ivolt;


   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%f", arg1, arg2, arg3, &volt );

   if ( volt > AMUIREFmax ) volt = AMUIREFmax;
   if ( volt < AMUIREFmin ) volt = AMUIREFmin;

   volt -= AMUIREFmin;
   volt *= -1.0;
   volt += (AMUIREFmax - AMUIREFmin);
   volt /= (AMUIREFmax - AMUIREFmin);
   volt *= 63.0;
   ivolt = volt + 0.5;

   /* now take the integer version (0-63) of the DAC value */
   /* and set the appropriate bits in the serial string    */

   for (i = 0; i < 6; i++) {
       if ( (ivolt & bitvals[i]) != 0 )
       {
          if ( amuchan==0 ) 
          {
            for ( amuchan2=0; amuchan2<8; amuchan2++ )
            {
              /* amuchan=0 means set this for all 8 channels */
              amubit[amuchan2][19+i] = 1;
            }
          }
          else
          {
              /* amuchan != 0 means set one channel */
              amubit[amuchan-1][19+i] = 1;
          }
       }
       else
       {
          if ( amuchan==0 ) 
          {
            for ( amuchan2=0; amuchan2<8; amuchan2++ )
            {
              /* amuchan=0 means set this for all 8 channels */
              amubit[amuchan2][19+i] = 0;
            }
          }
          else
          {
              /* amuchan != 0 means set one channel */
              amubit[amuchan-1][19+i] = 0;
          }
       }
   }

   return;
}
