#include <stdlib.h>
#include <stdio.h>
void MvdSetPhase( char cline[80], int hmbit[16] )
{
   /* Set 1/4 beam clock phase adjust                                */
   /* To simplify the input, this code expects a number from 0 to 3. */
   /* These correspond to a phase adjust on the level-1 delay between*/
   /* 0 and -3/4 beam clock ticks. Specifically:                     */
   /* phase = 0 -->  0.00 beam clocks --> hmbit[7]=0, hmbit[6]=0     */
   /* phase = 1 --> -0.25 beam clocks --> hmbit[7]=0, hmbit[6]=1     */
   /* phase = 2 --> -0.50 beam clocks --> hmbit[7]=1, hmbit[6]=0     */
   /* phase = 3 --> -0.75 beam clocks --> hmbit[7]=1, hmbit[6]=1     */
   /* some documentation on this bit can be found at :               */
   /* http://p25ext.lanl.gov/phenix/mvd/elect/mcmtest/lvl1_delay.html*/
   /* but beware, here I numbered hmbit values from 0 to 15, in that */
   /* document, they are numbers 1 to 16.                            */

   /* input cline, hmbit                                             */

   /* Author = JPSullivan 1-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   int i;
   char arg1[80];
   char arg2[80];
   int phase; 

   /* ********************************************************** */

   sscanf ( cline, "%s%s%d", arg1, arg2, &phase );
   if ( phase > 3 ) phase = 3;
   if ( phase < 0 ) phase = 0;
   /* fprintf ( stdout, " phase=-%d/4 beam clock adjust \n",phase); */
   if ( phase%2 == 1 ) 
        hmbit[6] = 1;
   else
        hmbit[6] = 0;
   if ( phase   >= 2 ) 
        hmbit[7] = 1;
   else
        hmbit[7] = 0;

   return;
}
