#include <stdlib.h>
#include <stdio.h>
void MvdSetTgvMux( char cline[80], int amuchan, int amubit[8][33] )
{
   /* Turn on Tgv MUX channel                                        */

   /* input cline   = the whole command line                         */
   /*       amuchan = the AMU channel this command applies to.       */
   /*                 numbering is 1-8 (not 0-7) because 0 ususally  */
   /*                 means set this bit for all channels. In this   */
   /*                 of this command amuchan=0 is illegal since only*/
   /*                 one MUX at a time should be on.                */
   /*       amubit  = The array of AMU serial string bits (an integer*/
   /*                 array containg 1's and 0's). First index is    */
   /*                 chip number, 2nd is the serial bit number.     */

   /* Author = JPSullivan 2-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int i;
   int onoff;
   int nchan; 
   int amuchan2;
   int bitvals[5] = {0x01, 0x02, 0x04, 0x08, 0x10};

   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%d%d", arg1, arg2, arg3, &onoff, &nchan );

   if ( nchan > 31 ) nchan = 31;
   if ( nchan < 0  ) nchan = 0;

   if ( onoff < 0  ) onoff = 0;
   if ( onoff > 1  ) onoff = 1;

   if ( amuchan == 0 ) 
   {
     fprintf ( stderr,
               "MvdSetTgvMux: command does not work for amuchan=0 (all chans), assume 1\n");
     amuchan = 1;
   }

   /* here we change the input amuchan variable to a new variable which */
   /* is used as an array index (0-7)                                   */

   amuchan2 = amuchan - 1;

   /* first turn all of the channels off, this makes sure */
   /* that more than one channel is not turned on         */

   for ( i=0; i<8; i++ )
   {
     amubit[amuchan2][26] = 0;
     amubit[amuchan2][27]= 0;
   }

   /* now turn on or off the requested channel */

   amubit[amuchan2][26] = onoff;
   amubit[amuchan2][27]= onoff;

   /* set the bits correspoding to the channel number */

   for ( i=0; i<5; i++ )
   {
     if ( (bitvals[i] & nchan) != 0 ) 
     { 
        amubit[amuchan-1][28+i] = 1;
     }
   }

   return;
}
