#include <stdlib.h>
#include <stdio.h>
void MvdSetTgvPredisC( char cline[80], int nchan, int tgvbit[8][190] )
{
   /* Disable preamp for one or more TGV channels                    */
   /* This is similar to MvdSetTgvPredis, but it expects an arguement*/
   /* which is just the channel, counting from 0 to 255. It figures  */
   /* out the chip number and bit number by itself.                  */
   /* This is used mainly for shorted channels in the Si -- if they  */
   /* are disabled, only the single bad channel is affected. If they */
   /* are not disabled, they stop 3 channels on either side (6 total)*/
   /* from working.                                                  */

   /* input cline   = the whole command line                         */
   /*       nchan   = channel to enable/disable, counts 0-255.       */
   /*       tgvbit  = The array of TGV serial string bits (an integer*/
   /*                 array containg 1's and 0's). First index is    */
   /*                 chip number, 2nd is the serial bit number.     */                  

   /* Author = JPSullivan 26-Jun-01 based MvdSetTgvPredis.c          */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int ichip;            /* chip number 0-7 */
   int jchan;            /* chan within chip 0-31  */
   int onoff;

   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%d", arg1, arg2, arg3, &onoff );

   if ( nchan > 255 ) nchan = 255;
   if ( nchan < 0   ) nchan = 0;

   if ( onoff < 0  ) onoff = 0;    /* 0 (normal) means channel is on */
   if ( onoff > 1  ) onoff = 1;    /* 1 means disable channel */

   /* disable the requested channel(s) */

   ichip = nchan/32;
   jchan = nchan - (ichip*32);

   /* set the bits corresponding to the channel number */

   tgvbit[ichip][96+jchan] = onoff;

   return;
}
