#include <stdlib.h>
#include <stdio.h>
void MvdSetTgvVmid( char cline[80], int tgvchan, int tgvbit[8][190] )
{
   /* Set Vmid DAC value for one TGV chip                            */

   /* input cline   = the whole command line                         */
   /*       tgvchan = the TGV channel this command applies to.       */
   /*                 numbering is 1-8 (not 0-7) because 0 usually   */
   /*                 means set this bit for all channels.           */
   /*       tgvbit  = The array of TGV serial string bits (an integer*/
   /*                 array containing 1's and 0's). First index is  */
   /*                 chip number, 2nd is the serial bit number.     */

   /* Author = JPSullivan 3-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int i;
   int tgvchan2;
   int bitvals[6] = {0x1, 0x2, 0x4, 0x8, 0x10, 0x20};
   float VMIDmin = 1.71;
   float VMIDmax = 4.50;
   float volt;
   int ivolt;


   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%f", arg1, arg2, arg3, &volt );

   if ( volt > VMIDmax ) volt = VMIDmax;
   if ( volt < VMIDmin ) volt = VMIDmin;

   volt -= VMIDmin;
   volt /= (VMIDmax - VMIDmin);
   volt *= 63.0;
   ivolt = volt + 0.5;

   /* now take the integer version (0-63) of the DAC value */
   /* and set the appropriate bits in the serial string    */

   for (i = 0; i < 6; i++) {
       if ( (ivolt & bitvals[i]) != 0 )
       {
          if ( tgvchan==0 ) 
          {
            for ( tgvchan2=0; tgvchan2<8; tgvchan2++ )
            {
              /* tgvchan=0 means set this for all 8 channels */
              tgvbit[tgvchan2][171-i] = 1;
            }
          }
          else
          {
              /* tgvchan != 0 means set one channel */
              tgvbit[tgvchan-1][171-i] = 1;
          }
       }
       else
       {
          if ( tgvchan==0 ) 
          {
            for ( tgvchan2=0; tgvchan2<8; tgvchan2++ )
            {
              /* tgvchan=0 means set this for all 8 channels */
              tgvbit[tgvchan2][171-i] = 0;
            }
          }
          else
          {
              /* tgvchan != 0 means set one channel */
              tgvbit[tgvchan-1][171-i] = 0;
          }
       }
   }

   return;
}
