#include <stdlib.h>
#include <stdio.h>
void MvdUnpackMcmSerial2( int SerialBitsIn[1800], 
                         int hmbit[16], int tgvbit[8][190], int amubit[8][33] )
{

   /* unpack data string into the blocks used by individual chips */

   /* input = SerialBitsIn          */
   /* output= hmbit, tgvbit, amubit */

   /* Author = JPSullivan 23-May-2000 (based on labwindows code */
   /*          originally written by BSchlei and SSRyu)         */

   /* Modifications: 4-Aug-2000 JPS had to change order of bits */
   /*                in amubit and tgvbit arrays.               */

   /* ********************************************************* */

    int i;
    int datbit2[1800];
    int val1, val2;
    int bcnt;
    int iind;
    int j;

   /* ********************************************************** */

/* take SerialBitsIn,  reverse it and put the results into datbit2 */

   for (bcnt = 0; bcnt < 1800; bcnt++) {
      val2 = SerialBitsIn[bcnt];
      val1 = 1799 - bcnt;	/* bit number */
      datbit2[val1] = val2;  	/* bit value  */
   }

    for (i = 0; i < 16; i++) {
        /* order reversed 10-May-2001 */
        hmbit[15-i] = datbit2[i];                /* heap manager */
    }
    iind = 16;
    
    for (j = 0; j < 8; j++) {
        for (i = 0; i <190; i++) {
            tgvbit[j][189-i] = datbit2[iind+i];  /* TGVs */
        }
        iind += 190;
    }

    for (j = 0; j < 8; j++) {
        for (i = 0; i < 33; i++) {
            amubit[j][32-i] = datbit2[iind+i];  /* AMUs */
        }
        iind += 33;
    }
        
    return;
}
